/*
 * iTunes Signature Maker
 * copyright (c) 2005 by Jason Freeman
 * 
 * For more information, please visit http://www.jasonfreeman.net/itsm/
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 */

package net.jasonfreeman.itsm.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

import net.jasonfreeman.itsm.ITSM;
import net.jasonfreeman.itsm.util.ErrorHandler;

/**
 * Placeholder panel when signature making is canceled, with restart button.
 * 
 * @author jason
 *
 */

public class CanceledPanel extends JPanel implements ActionListener {

	JButton restartButton;
	ITSM applet;
	
	public CanceledPanel(ITSM applet) {
		super();
		this.applet = applet;
		setBackground(Color.white);
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        add(Box.createVerticalGlue());
        
        JPanel textPanel = new JPanel();
        textPanel.setBackground(Color.white);
        textPanel.setLayout(new BoxLayout(textPanel, BoxLayout.X_AXIS));
        textPanel.add(Box.createRigidArea(new Dimension(50, 0)));
        JLabel label = new JLabel("The signature-making process has been canceled.");
        label.setFont(label.getFont().deriveFont(Font.BOLD));
        textPanel.add(label);
        textPanel.add(Box.createHorizontalGlue());
        add(textPanel);
        add(Box.createVerticalGlue());
        add(new HorizontalSeparator());
        add(Box.createVerticalGlue());
        add(Box.createVerticalGlue());
        add(Box.createVerticalGlue());
        add(Box.createVerticalGlue());
        
        JPanel restartPanel = new JPanel();
        restartPanel.setBackground(Color.white);
        restartPanel.setLayout(new BoxLayout(restartPanel, BoxLayout.X_AXIS));
        restartPanel.add(Box.createHorizontalGlue());
        restartButton = new JButton("restart iTSM");
        restartButton.addActionListener(this);
        restartButton.setBackground(Color.white);
        restartPanel.add(restartButton);
        restartPanel.add(Box.createHorizontalGlue());
        add(restartPanel);
        add(Box.createVerticalGlue());
        add(Box.createVerticalGlue());
        add(Box.createVerticalGlue());
        add(Box.createVerticalGlue());

        applet.setContentPane(this);
        applet.validate();
	}

	public void actionPerformed(ActionEvent e) {
		try {
			if (e.getSource() == restartButton) {
			    setVisible(false);
				Runnable t = new Runnable() {
					public void run() {
						try {
						    applet.restart();
						} catch (Throwable e) {
							ErrorHandler.getInstance().handleError(e);
						}
					}
				};
				new Thread(t).start();
			}
		} catch (Throwable e1) {
			ErrorHandler.getInstance().handleError(e1);
		}
	}
}
