/*
 * iTunes Signature Maker
 * copyright (c) 2005 by Jason Freeman
 * 
 * For more information, please visit http://www.jasonfreeman.net/itsm/
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details. You should have received a copy of the GNU General
 * Public License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 */

package net.jasonfreeman.itsm.selection;

public class RatingComparer implements SongComparer {

	/* (non-Javadoc)
	 * @see net.jasonfreeman.itsm.selection.SongComparer#betterThan(net.jasonfreeman.itsm.selection.Song, net.jasonfreeman.itsm.selection.Song)
	 */
	public boolean betterThan(Song song, Song song2) {
		int rating = song.getRating();
		int rating2 = song2.getRating();
		if (rating != rating2)
			return (rating > rating2);
        if (song.getPlayCount() == song2.getPlayCount()) {
            if (song.getLastPlayed() == null)
                return false;
            else if (song2.getLastPlayed() == null)
                return true;
            return (song.getLastPlayed().compareTo(song2.getLastPlayed()) > 0);
        }
        return (song.getPlayCount() > song2.getPlayCount());
	}
}
